<?php

error_reporting(E_ERROR | E_PARSE);
set_time_limit(-1);
ini_set('max_input_time', '-1');
ini_set('max_execution_time', '0');
session_start();
ob_start();

/*
  Copyright (C) 2021 Hash Borgir

  This file is part of D2Modder

  Redistribution and use in source and binary forms, with
  or without modification, are permitted provided that the
  following conditions are met:

 * Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

 * Redistributions in binary form must reproduce the above
  copyright notice, this list of conditions and the
  following disclaimer in the documentation and/or other
  materials provided with the distribution.

 * This software must not be used for commercial purposes
 * without my consent. Any sales or commercial use are prohibited
 * without my express knowledge and consent.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY!

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 */
require_once './config.php';
require_once './_pdo.php';
require_once './src/D2ItemData.php';
require_once './src/D2ItemDesc.php';

$idata = new D2ItemData();
$idesc = new D2ItemDesc();

define('DB_FILE', $_SESSION['modname'] . ".db");
PDO_Connect("sqlite:" . DB_FILE);

require_once "./src/D2Functions.php";

$idata = new D2ItemData();

if (!empty($_GET['cmd']))
	$cmd = $_GET['cmd'];


if ($cmd == 'genDocCube') {
	$type = "Cube Recipes";
	$align = 'left';
}
if ($cmd == 'genDocUniqueItems') {
	$type = "Unique Items";
	$align = 'center';
}
$sql = "
		SELECT p.`code` as prop,
			p.stat1,
			i.descstrpos,
			i.descstr2,
			i.descfunc,
			i.descval,
			i.dgrp,
			i.dgrpfunc,
			i.dgrpval,
			i.dgrpstrpos,
			i.dgrpstrneg,
			s1.String as string1,
			s2.String as string2,
			s3.String as gstring1,
			s4.String as gstring2
		FROM properties as p

		LEFT JOIN itemstatcost as i
		ON p.stat1 = i.Stat

		LEFT JOIN strings as s1
		ON i.descstrpos = s1.Key
		LEFT JOIN strings as s2
		ON i.descstr2 = s2.Key

		LEFT JOIN strings as s3
		ON i.dgrpstrpos = s3.Key
		LEFT JOIN strings as s4
		ON i.dgrpstr2= s4.Key
		";
$res = PDO_FetchAll($sql);

$isc = null;
foreach ($res as $r) {
	$isc[$r['prop']] = $r;
	$isc[$r['prop']]['prop'] = $r['prop'];
}

// load strings

        	$sql = 'SELECT * FROM strings';
          $strings =  array_filter(PDO_FetchAssoc($sql));

          
    // load itemtypes table in memory
    // then in side this foreach loop for each row, see if the item code appears in itemtypes
    // if in item types, then it's a 4 letter code, done
    // if not in itemtypes,  then it's a three letter code and get the string for it from tbl
    
    	$sql = "SELECT ItemType,Code FROM itemtypes";       
	$itemtypesTbl = PDO_FetchAssoc($sql);
    
//    	$sql = "SELECT ItemType,Equiv1 FROM itemtypes";       
//	$itemtypesTblEquiv1 = PDO_FetchAssoc($sql);
//
//    	$sql = "SELECT ItemType,Equiv2 FROM itemtypes";       
//	$itemtypesTblEquiv2 = PDO_FetchAssoc($sql);    
//   $itemTypes = array_filter(array_merge($itemtypesTblCode, $itemtypesTblEquiv1, $itemtypesTblEquiv1));
    
//    ddump($itemtypesTbl);

    
    
// load namestr from 3 files
    $sql = "SELECT code,namestr FROM armor
            UNION
            SELECT code,namestr FROM misc
            UNION
            SELECT code,namestr FROM weapons
        ";
    $namestr = PDO_FetchAssoc($sql);
    
    
    
$htmltop = <<<EOT
<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="res/bootstrap.min.css">
	<link rel="stylesheet" href="res/font-awesome.min.css">
	<link rel="preconnect" href="https://fonts.gstatic.com">
	<link href="https://fonts.googleapis.com/css2?family=Lato:wght@300&display=swap" rel="stylesheet">
	<link rel="stylesheet" href="https://bootswatch.com/4/sketchy/bootstrap.min.css">
     <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.24/css/jquery.dataTables.css">
	<link rel="stylesheet" href="res/style.css">
	<style>

	body{
		background: white;
		font-family: ExocetLight;
	}

	 table, table th, table td, table tr {
		background: #111;
		color: #ccc;
   }
.item {
	text-align: center;
	position:relative;
	right:0px;
	margin: 0 auto;
}

.item_desc {
	height: 600px;
	width: 620px;
    position: relative;
    left: 0px;
    top: 0px;

    text-align: center;
    padding: 10px;
	text-transform: uppercase;

}

	.item_stats{
		width: auto;
		height: auto;
	   background: #111;
	   min-height: 260px;
	}
	.item_desc {
		height: auto;
		text-align: center;
		padding: 10px;
		text-transform: uppercase;
	}
	.green {
		color: #00FF00; /*Set items*/
	}
	.gold{
		color: #A59263; /*Set items*/
	}
	.orange{
		color: #FFA500; /*Set items*/
	}
	.yellow {
		color: #FFFF00; /*Set items*/
	}

    .blue {
		color: #4169E1;
    }
	td {

		height: 240px;

		text-align: center;
		vertical-align: middle;
		padding: 10px;
	}


    .uname {
		background: #222;
	}
	.ulvl {

	}
	.ulvlreq {

	}
	.utype {
		background: #111;
	}
	.ucode {

	}
	.uitem {

	}
                    .rprops {                     
                     background: #222 !important;
                     border: 1px solid #ccc;
                     padding: 30px 5px;
                    }

		.rw {
			text-align: center;
			border: 1px solid #ccc;
			margin: 10px;
			padding: 10px;
			background: #111;
			                              
		}
		.rw-name {font-size: 28px;text-align: center;}
		.rw-type { font-family: ExocetLight; }
		.rw-rune { color: #ccc; }
                     .rw-count {
                         background: #222;
                         border: 1px solid #ccc;
                         border-radius: 50;
                        display: block;
                        height: 60px;
                        width: 60px;
                        line-height: 60px;

                        -moz-border-radius: 30px; /* or 50% */
                        border-radius: 30px; /* or 50% */

                         margin: 0 auto;
                        color: white;
                        text-align: center;
                        font-size: 2em;        
                     }
                     .rune-img {
                       padding: 1px;
                       margin:1px;
                       height: 48px;
                       width: 48px;
       
                      }
        
                      .numrunes {
                          color: 
                      }

	</style>  

    <script src="res/jquery-3.5.1.min.js"></script>
    <script src="res/bootstrap.bundle.min.js"></script>

    <link rel="stylesheet" type="text/css" href="res/datatables.min.css"/>
    <script type="text/javascript" src="res/datatables.min.js"></script>
        
    <script>
        $(document).ready(function() {
         $('.cubetable').dataTable();
        $('.utable').dataTable();
        $('.gemtable').dataTable();
        $('.rtable').dataTable();
        } );
    </script>

<title>D2Modder</title>
</head>

<body>
	<div class="">
<h1>{$_SESSION['modname']} $type</h1>
<p>Auto generated with D2Modder by Hash Casper</p>

EOT;

$htmlbottom = <<<EOT
		</div>

</body>
</html>
EOT;

/*
 *
 *
 *
 *
 *
  @cmd = genDocUniqueItems
 *
 *
 *
 *
 *
 */
$dir = getcwd() . "/docs/{$_SESSION['modname']}";
mkdir($dir, 0777, true);

if ($cmd == "genDocUniqueItems") {

	$tableTop = <<<EOT
			<table border=1 class="utable">
	<thead>
			<tr>
				<th class="gold uname">Name</th>
				<th class="orange ulvl">Lvl</th>
				<th class="orange ulvlreq">Lvl Req</th>
				<th class="yellow utype">Type</th>
				<th class="green ucode">Code</th>
				<th class="uitem">Item</th>
			</tr>
	</thead>
	<tbody>
EOT;

	$tableBottom = <<<EOT
	</tbody>
	</table>
EOT;

	// grab unique item index only (to save on memory)
	$sql = "SELECT `index` FROM `uniqueitems` WHERE `enabled`='1'";
	$uIndex = PDO_FetchAll($sql);

	//ddump($uIndex);




	$htmlFinal = '';
	$htmlFinal .= $htmltop . $tableTop;

	echo $htmltop;
	echo $tableTop;
	ob_flush();

	/*
	  START MAIN LOOP HERE
	 *
	 * 	For each unique item index, now grab item data
	 *
	 */



	foreach ($uIndex as $u) {
		//var_dump($item);
		//$items[] = $idata->uniqueItems($u['index'], true);
		//var_dump($u['index']);

		$item = $idata->uniqueItems($u['index'], true);

		$itemBoxTop = "<tr>";
		$itemBoxTop .= "<td class='gold uname' style=''>{$item['index']}</td>";
		$itemBoxTop .= "<td class='orange ulvl' style=''>{$item['lvl']}</td>";
		$itemBoxTop .= "<td class='orange ulvlreq' style=''>{$item["lvl req"]}</td>";
		$itemBoxTop .= "<td class='utype' style=''>{$item["*type"]}</td>";
		$itemBoxTop .= "<td class='ucode' style=''>{$item['code']}</td>";

		$itemBoxTop .= <<<EOT
<td class='item' style=''>
<div class="center item_desc" style="">

	<div style="height: 116px;background: url(img/items/bg.png) center top no-repeat;">
			<img style="" class="item img-fluid" src="img/items/{$item["invfile"]}.png">
	</div>
	<div class="item_stats" style="">
		<div style="width:auto; margin: 0 auto; background:#111; display:inline-block;">
			<p>
EOT;
		$itemBoxBottom = <<<EOT
			</p>
		</div>
	</div>
</div>
</td>
EOT;
		$itemBoxBottom .= "</tr>";

		echo $itemBoxTop;
		ob_flush();

		$htmlFinal .= $itemBoxTop;

		//index
		$props = "<ul><li class='statindex gold'>{$item['index']}</li>";

		//type
		$props .= "<li class='stattype gold'>({$item["*type"]})</li>";

		//level
		$props .= "<li style='color: white;' class=''>Level: {$item["lvl"]}</li>";

		//lvlreq
		$props .= "<li style='color: white;' class=''>Level Required: {$item["lvl req"]}</li>";

		//code
		$props .= "<li style='color: #aaa;' class=''>Item Code: {$item["code"]}</li>";

		//reqstr
		if ($item["reqstr"]) {
			$props .= "<li  style='color: white;' class=''>{$item["reqstr"]}</li>";
		}
		//reqdex
		if ($item["reqdex"]) {
			$props .= "<li  style='color: white;' class=''>{$item["reqdex"]}</li>";
		}
		//sock
		$props .= "<li  style='color: white;'  class=''>{$item["gemsockets"]}</li>";

		foreach ($item['props'] as $prop) {
			if ($prop['string'][0]) {
				$props .= "<li class='blue'>{$prop['string'][0]}</li>";
			}
		}

		$props .= "</ul>";

		// $itemFull .= $itemBoxTop . $props . $itemBoxBottom;
		// echo $itemFull;

		echo $props;
		echo $itemBoxBottom;
		ob_flush();

		$htmlFinal .= $props . $itemBoxBottom;
	}// end loop

	$htmlFinal .= $tableBottom;
	
	echo $htmlbottom;

	$htmlFinal .= $htmlbottom;
	file_put_contents("$dir/uniqueitems.html", $htmlFinal);
	header("Location: /docs/{$_SESSION['modname']}/uniqueitems.html");
}


/*
 *
 *
 *
 *
 *
  @cmd = genDocCube
 *
 *
 *
 *
 *
 */

function getImage($code) {
	$sql = "SELECT invfile FROM armor WHERE `code`=\"$code\" OR `type`=\"$code\" OR `type2`=\"$code\"";
	$img = PDO_FetchOne($sql);

	if (empty($img)) {
		$sql = "SELECT invfile FROM misc WHERE `code`=\"$code\" OR `type`=\"$code\" OR `type2`=\"$code\"";
		$img = PDO_FetchOne($sql);
	}
	if (empty($img)) {
		$sql = "SELECT invfile FROM weapons WHERE `code`=\"$code\" OR `type`=\"$code\" OR `type2`=\"$code\"";
		$img = PDO_FetchOne($sql);
	}

	if (!empty($img)) {
		return "$img.png";
	} else {
		return "1.png";
	}

	return "$img.png";
}

function getItemName($code) {
	$sql = "SELECT name FROM armor WHERE `code`=\"$code\" OR `type`=\"$code\" OR `type2`=\"$code\"";
	$name = PDO_FetchOne($sql);

	if (empty($name)) {
		$sql = "SELECT name FROM misc WHERE `code`=\"$code\" OR `type`=\"$code\" OR `type2`=\"$code\"";
		$name = PDO_FetchOne($sql);
	}
	if (empty($name)) {
		$sql = "SELECT name FROM weapons WHERE `code`=\"$code\" OR `type`=\"$code\" OR `type2`=\"$code\"";
		$name = PDO_FetchOne($sql);
	}

	return $name;
}

if ($cmd == "genDocCube") {
	$htmlFinal = '';
	$htmlFinal .= $htmltop;
//	echo $htmltop;
//	ob_flush();
	$css = <<<EOT
	<style>

	body{
		background: white;
		color: black;
		font-family: ExocetLight;
		text-transform: uppercase;
	}



	 table, table th, table td, table tr {
		background: #111;
		color: #ccc;
   }

	.item_stats{
		width: auto;
		height: auto;
	}
	.item_desc {
		height: auto;
		text-align: center;
		padding: 10px;
		text-transform: uppercase;
	}
	.green {
		color: #00FF00; /*Set items*/
	}
	.gold{
		color: #A59263; /*Set items*/
	}
	.orange{
		color: #FFA500; /*Set items*/
	}
	.yellow {
		color: #FFFF00; /*Set items*/
	}

    .blue {
		color: #4169E1;
    }

	table {
    }

	.desc {
		width: 200px;
		font-family: ExocetLight;
		font-size: 1.25em;
		text-transform: uppercase;
		background: #111;
    }

	.input1,.input3,.input5,.input7{
		background: #444;
    }
	.input2, .input4, .input6 {
		background: #333;
    }
	.output1{
		background: #222;
	}
	.output2 {
		background: #222;
	}
	.output3 {
		background: #222;
	}

	td {

		height: 240px;

		text-align: center;
		vertical-align: middle;
		padding: 10px;
}
	</style>
EOT;
	//echo $css;
	$htmlFinal .= $css;
	//ob_flush();
	$table = <<<EOT
			<table border=1 class="cubetable">
	<thead>
			<tr>
				<th>Recipe</th>
				<th>Input 1</th>
				<th>Input 2</th>
				<th>Input 3</th>
				<th>Input 4</th>
				<th>Input 5</th>
				<th>Input 6</th>
				<th>Input 7</th>
				<th>Output 1</th>
				<th>Output 2</th>
				<th>Output 3</th>
			</tr>
	</thead>
	<tbody>
EOT;
	//echo $table;
	$htmlFinal .= $table;
	//ob_flush();
	$i_params = [
		"any" => "Any Item",
		"low" => "Low Quality",
		"hiq" => "Superior",
		"nor" => "Normal",
		"mag" => "<span class='blue'>Magic<span>",
		"rar" => "<span class='yellow'>Rare<span>",
		"set" => "<span class='green'>Set<span>",
		"uni" => "<span class='gold'>Unique<span>",
		"crf" => "<span class='orange'>Crafted<span>",
		"tmp" => "<span class='orange'>Tempered<span>",
		"eth" => "<span style='color: #ccc;'>Ethereal<span>",
		"noe" => "<span style='color: #ccc;'>Not Ethereal<span>",
		"nos" => "No Socket (for input)",
		"sock" => "Sockets",
		"pre" => "Prefix (ID from magicprefix.txt) - ID => (Row Number - 2)",
		"suf" => "Suffix (ID from magicsuffix.txt) - ID => (Row Number - 2)",
		"rep" => "Repair durability",
		"rch" => "Recharge Quantity",
		"qty" => 'Quantity',
		"upg" => "For inputs only, Item is upgraded.",
		"bas" => "Base item",
		"exc" => "Exceptional",
		"eli" => "Elite",
		"usetype" => "Uses base type of input1 for output",
		"useitem" => "Uses item from input 1",
		"uns" => "Unsocket Item(destroys gems)",
		"rem" => "Unsocket Item(removes gems)",
		"reg" => "Regenerate? Seems to reroll the item",
		"mod" => "Transfers properties from input1 to output item.",
	];

	// get all cube rows
	$sql = "SELECT * FROM cubemain WHERE enabled=1";
	$res = PDO_FetchAll($sql);

	/*
	 *
	 * 	Process each cube row here
	  for each cube row
	 *
	 */
       
	foreach ($res as $r) {
		$desc = str_replace('+', '<br>+<br>', $r['description']);
		$desc = str_replace('->', '<br><span class="" style="color: gold;font-size:1.25em;">=<br>', $desc);
		$desc .= "</span>";
		//ddump($desc);
		//var_dump($r);
		// grab all inputs
		$input_codes = array_filter(
				[
					"input 1" => $r["input 1"],
					"input 2" => $r["input 2"],
					"input 3" => $r["input 3"],
					"input 4" => $r["input 4"],
					"input 5" => $r["input 5"],
					"input 6" => $r["input 6"],
					"input 7" => $r["input 7"],
				]
		);

		foreach ($input_codes as $inputNum => $value) {

			if (str_contains($value, ',')) {
				$input_codes[$inputNum] = explode(",", $value); // hpot,qty=3

				$oarray = explode(",", $value); // hpot,qty=3
				// For each input code // hpot,qty=3 like mpot/hpot/magharv
				// if spelldescstr is set, use it. Else use item string tbl
				// first find the item code in either armor, misc, or weapons
				// then get spelldesc/spelldescstr


//				$sql = "SELECT `String` FROM `strings` WHERE Key=\"{$oarray[0]}\"";
//				$str = PDO_FetchOne($sql);
                
                    $str = $strings[$oarray[0]];

				// if empty str == 4-letter code, call getItemName()
				if (empty($str)) {
					$input_codes[$inputNum][0] = ($oarray[0]);
				} else {
					$input_codes[$inputNum][0] = $str;
				}

				// get image
				$input_codes[$inputNum]["img"] = getImage($oarray[0]);
			} else {
				$value .= ",";
				$input_codes[$inputNum] = explode(",", $value); // hpot,qty=3

				$oarray = explode(",", $value); // hpot,qty=3
				// For each input code // hpot,qty=3 like mpot/hpot/magharv
				// if spelldescstr is set, use it. Else use item string tbl
				// first find the item code in either armor, misc, or weapons
				// then get spelldesc/spelldescstr


//				$sql = "SELECT `String` FROM `strings` WHERE Key=\"{$oarray[0]}\"";
//				$str = PDO_FetchOne($sql);
                
                    $str = $strings[$oarray[0]];

				// if empty str == 4-letter code, so just display
				if (empty($str)) {
					$input_codes[$inputNum][0] = ($oarray[0]);
				} else {
					$input_codes[$inputNum][0] = $str;
				}

				// get image
				$input_codes[$inputNum]["img"] = getImage($oarray[0]);
			}
		}

		/*
		 * processs output, output b, output c
		 *
		 *
		 */

		// grab all inputs
		$output_codes = array_filter(
				[
					"output" => str_replace('"', "", $r["output"]),
					"output b" => str_replace('"', "", $r["output b"]),
					"output c" => str_replace('"', "", $r["output c"])
				]
		);

		// dump($output_codes);
		foreach ($output_codes as $outputNum => $value) {

			if (str_contains($value, ',')) {
				$output_codes[$outputNum] = explode(",", $value); // hpot,qty=3
				$oarray = explode(",", $value); // hpot,qty=3
				$sql = "SELECT `String` FROM `strings` WHERE Key=\"{$oarray[0]}\"";

				// clean str
				$str = PDO_FetchOne($sql);

				if (str_contains($str, "ÿc")) {
					$p = "/ÿc[\d:;\/.]/i";
					$str = preg_replace($p, "", $str);
				}

				// if empty str == 4-letter code, so just display
				if (empty($str)) {
					$output_codes[$outputNum][0] = ($oarray[0]);
				} else {
					$output_codes[$outputNum][0] = $str;
				}

				$output_codes[$outputNum]["img"] = getImage($oarray[0]);
			} else { // else output code is three/four letter code
				$value .= ",";

				$output_codes[$outputNum] = explode(",", $value); // hpot,qty=3
				$oarray = explode(",", $value); // hpot,qty=3
				$sql = "SELECT `String` FROM `strings` WHERE Key=\"{$oarray[0]}\"";

				// clean color codes
				$str = PDO_FetchOne($sql);

				if (str_contains($str, "ÿc")) {
					$p = "/ÿc[\d:;\/.]/i";
					$str = preg_replace($p, "", $str);
				}


				// if empty str == 4-letter code, so just display
				if (empty($str)) {
					$output_codes[$outputNum][0] = ($oarray[0]);
				} else {
					$output_codes[$outputNum][0] = $str;
				}

				$output_codes[$outputNum]["img"] = getImage($oarray[0]);
			}


			// if output[1] or output[2], output[3], output[4] contains `=' sign
			// parse_str or explode at = to get modifer and value
			// if modifier = pre or suf, find ID in magic prefix/suffix line.
			// if output is array we know it contains modifers and values

			if (is_array($output_codes[$outputNum])) {
				// 0 will always be item code.
				// 1,2,3 can be mods, either can have =
				// if 1,2,3 have = sign, explode and get mod = value

				$itemcode = $output_codes[0];

				$mod = array_filter([$output_codes[$outputNum][1], $output_codes[$outputNum][2], $output_codes[$outputNum][3]]);

				//var_dump($mod);

				foreach ($mod as $m) {
					if (str_contains($m, '=')) {
						$e = explode("=", $m);
						$output_codes[$outputNum]['code'] = $e[0];
						$output_codes[$outputNum]['value'] = $e[1];
					}
				}
			}
		}

		$output = array_merge($input_codes, $output_codes);

		// Set description
		$output['desc'] = $desc;

		/*
		 * process mods for each output
		 *
		 *
		 */

		$m = null;

		for ($counter = 1; $counter <= 5; $counter++) {
			$mods = array_filter([
				"mod $counter" => $r["mod $counter"],
				"mod $counter chance" => $r["mod $counter chance"],
				"mod $counter param" => $r["mod $counter param"],
				"mod $counter min" => $r["mod $counter min"],
				"mod $counter max" => $r["mod $counter max"],
				"b mod $counter" => $r["b mod $counter"],
				"b mod $counter chance" => $r["b mod $counter chance"],
				"b mod $counter param" => $r["b mod $counter param"],
				"b mod $counter min" => $r["b mod $counter min"],
				"b mod $counter max" => $r["b mod $counter max"],
				"c mod $counter" => $r["c mod $counter"],
				"c mod $counter chance" => $r["c mod $counter chance"],
				"c mod $counter param" => $r["c mod $counter param"],
				"c mod $counter min" => $r["c mod $counter min"],
				"c mod $counter max" => $r["c mod $counter max"],
			]);

			$m[] = array_filter($mods);
		}
		$output['mods'] = array_filter($m);

		$result = [];

		//var_dump($output['mods']);
		foreach ($output['mods'] as $k => $v) {
			$prop = ($v["mod " . $k + 1]);
			$par = ($v["mod " . $k + 1 . " param"]) ?? "";
			$min = ($v["mod " . $k + 1 . " min"]) ?? $max;
			$max = ($v["mod " . $k + 1 . " max"]) ?? $min;

			//var_dump($min);

			$output['mods'][$k]["isc"] = $isc[$prop];
			$params = [
				'string1' => $output['mods'][$k]["isc"]['string1'],
				'string2' => $output['mods'][$k]["isc"]['string2'],
				'descfunc' => $output['mods'][$k]["isc"]['descfunc'],
				'descval' => $output['mods'][$k]["isc"]['descval'],
				"prop" => $prop,
				"par" => $par,
				"min" => $min,
				"max" => $max,
					// "val1" => $funcval['val1'],
					// "func1" => $funcval['func1']
					// 'item' => $return
			];

			$output['mods'][$k]["str"] = $idesc->getDesc($params);
			//ddump($output['mods'][$k]["isc"]);
		}

		//ddump($idata->getIscStrings("energy"));
    

		/*
		 *  Echo out each row as HTML with all the data it may have
		 *
		 */

//		echo "<tr>";
//		foreach ($output as $k => $v) {
//
//			// if input 1, input 2 is an array
//
//			if (is_array($v)){
//				echo "<td><img src=\"/img/items/{$v['img']}\">{$v[0]}: {$v[1]}</td>";
//				echo "<td><img src=\"/img/items/{$v['img']}\">{$v[0]}: {$v[1]}</td>";
//			} else {
//
//				$img = "";
//			// if input 1, input 2 ... etc. are not arrays
//				echo '<td><img src="'.$o.'"></td>';
//			}
//		}
//		echo "</tr>";


		$htmlRow = "<tr>";
		$htmlRow .= "<td class='desc'>" . $output['desc'] . "</td>";

		for ($i = 1; $i <= 7; $i++) {

			$htmlRow .= "<td class='input$i'>";
			if (!empty($output["input $i"]["img"])) {
				$htmlRow .= "<img src='img/items/{$output["input $i"]["img"]}'><br>";
				if (str_contains($output["input $i"][0], "ÿc")) {
					$p = "/ÿc[\d:;\/.]/i";
					$output["input $i"][0] = preg_replace($p, "", $output["input $i"][0]);
				}                             
                
                               
                // if the item is in itemtypes grab it, it's 4 letter code fron itemtypes
                
                $key1 = array_search($output["input $i"][0], $itemtypesTbl);
                
                // if the key's value is in itemtypes
                if($itemtypesTbl[$key1] == $output["input $i"][0]){
                    $ostr = implode("<br>", (array_reverse(explode('\n', $key1))));
                } else {
                    $ostr = implode("<br>", (array_reverse(explode('\n', $output["input $i"][0]))));
                }
          				
                echo '<pre>';    
                
				$htmlRow .= $ostr . "<br>";
				if (str_contains($output["input $i"][1], "=")) {
					$htmlRow .= $output["input $i"][1] . "<br>";
				} else {
					$htmlRow .= $i_params[$output["input $i"][1]] . "<br>";
				}
			}
			$htmlRow .= "</td>";
		}


		$htmlRow .= "<td class='output1'>";
		if (!empty($output["output"]["img"])) {
			$htmlRow .= "<img src='img/items/{$output["output"]["img"]}'><br>";
			if (str_contains($output["output"][0], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$output["output"][0] = preg_replace($p, "", $output["output"][0]);
			}
            
            $key1 = array_search($output["input $i"][0], $itemtypesTbl);
            
            //var_dump($output);
            
               // if the item is in itemtypes grab it, it's 4 letter code fron itemtypes
                
                $key1 = array_search($output["input $i"][0], $itemtypesTbl);
            
			if (str_contains($output["output"][1], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$output["output"][1] = preg_replace($p, "", $output["output"][1]);
			}
			if ($i_params[$output["output"][0]]) {
				$htmlRow .= '<span style="color: #AF833B;">' . $output["output"][0] . "</span><br>";
			} else {
				$htmlRow .= $output["output"][0] . "<br>";
			}
			if ($i_params[$output["output"][1]]) {
				$htmlRow .= $i_params[$output["output"][1]] . "<br>";
			} else {
				$htmlRow .= $output["output"][1] . "<br>";
			}

			for ($i = 1; $i <= 5; $i++) {

				if ($output["mods"][0]["mod $i"]) {
					if (str_contains($output["mods"][0]["str"], "ÿc")) {
						$p = "/ÿc[\d:;\/.]/i";
						$output["mods"][0]["str"] = preg_replace($p, "", $output["mods"][0]["str"]);
					}



					$htmlRow .= str_replace("\n", "<br>", "<span class='blue'>{$output["mods"][0]["str"]}</span><br><br>");
				}

				if ($output["mods"][0]["mod $i chance"]) {
					$htmlRow .= "<span style='color: #FFA500'>Chance:{$output["mods"][0]["mod $i chance"]}</span><br>";
				}
			}
		}
		$htmlRow .= "</td>";

		$htmlRow .= "<td class='output2'>";
		if (!empty($output["output b"]["img"])) {
			$htmlRow .= "<img src='img/items/{$output["output b"]["img"]}'><br>";
			if (str_contains($output["output b"][0], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$output["output b"][0] = preg_replace($p, "", $output["output b"][0]);
			}
			if (str_contains($output["output b"][1], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$output["output b"][1] = preg_replace($p, "", $output["output b"][1]);
			}
			$htmlRow .= $output["output b"][0] . "<br>";
			$htmlRow .= $output["output b"][1] . "<br>";
			for ($i = 1; $i <= 5; $i++) {

				if ($output["mods"][1]["mod $i"]) {
					$htmlRow .= "{$output["mods"][1]["mod $i"]}<br>";
				}

				if ($output["mods"][1]["mod $i chance"]) {
					$htmlRow .= "Chance:{$output["mods"][1]["mod $i chance"]}<br>";
				}

				if ($output["mods"][1]["mod $i min"]) {
					$htmlRow .= "Min:{$output["mods"][1]["mod $i min"]}<br>";
				}
				if ($output["mods"][1]["mod $i max"]) {
					$htmlRow .= "Max:{$output["mods"][1]["mod $i max"]}";
				}
			}
		}
		$htmlRow .= "</td>";
            
		$htmlRow .= "<td class='output3'>";
		if (!empty($output["output c"]["img"])) {
			$htmlRow .= "<img src='img/items/{$output["output c"]["img"]}'><br>";
			if (str_contains($output["output c"][0], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$output["output c"][0] = preg_replace($p, "", $output["output c"][0]);
			}
			if (str_contains($output["output c"][1], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$output["output c"][1] = preg_replace($p, "", $output["output c"][1]);
			}
			$htmlRow .= $output["output c"][0] . "<br>";
			$htmlRow .= $output["output c"][1] . "<br>";
			for ($i = 1; $i <= 5; $i++) {

				if ($output["mods"][2]["mod $i"]) {
					$htmlRow .= "{$output["mods"][2]["mod $i"]}<br>";
				}

				if ($output["mods"][2]["mod $i chance"]) {
					$htmlRow .= "Chance:{$output["mods"][2]["mod $i chance"]}<br>";
				}

				if ($output["mods"][2]["mod $i min"]) {
					$htmlRow .= "Min:{$output["mods"][2]["mod $i min"]}<br>";
				}
				if ($output["mods"][2]["mod $i max"]) {
					$htmlRow .= "Max:{$output["mods"][2]["mod $i max"]}";
				}
			}
		}
		$htmlRow .= "</td>";
		$htmlRow .= "</tr>";

//		echo $htmlRow;
//		ob_flush();

		$htmlFinal .= $htmlRow;

		//ddump($i_params['levelreq']);
		//var_dump($output);
		//ob_flush();
		unset($output);
	}// end each row loop
	$tableBottom = <<<EOT
	</tbody>
	<table>
EOT;
	//echo $tableBottom;
	//echo $htmlbottom;
	//ob_flush();

	$htmlFinal .= $tableBottom . $htmlbottom;

    
    
	file_put_contents("$dir/cubemain.html", $htmlFinal);
	header("Location: docs/{$_SESSION['modname']}/cubemain.html");
}




//if ($cmd == "getIscStrings") {
//
//
//
//	$sql = "
//			SELECT p.`code` as prop,
//				p.stat1,
//				i.descstrpos,
//				i.descstr2,
//				i.descfunc,
//				i.descval,
//				i.dgrp,
//				i.dgrpfunc,
//				i.dgrpval,
//				i.dgrpstrpos,
//				i.dgrpstrneg,
//				s1.String as string1,
//				s2.String as string2,
//				s3.String as gstring1,
//				s4.String as gstring2
//			FROM properties as p
//
//			LEFT JOIN itemstatcost as i
//			ON p.stat1 = i.Stat
//
//			LEFT JOIN strings as s1
//			ON i.descstrpos = s1.Key
//			LEFT JOIN strings as s2
//			ON i.descstr2 = s2.Key
//
//			LEFT JOIN strings as s3
//			ON i.dgrpstrpos = s3.Key
//			LEFT JOIN strings as s4
//			ON i.dgrpstr2= s4.Key
//";
//
//	$res = PDO_FetchAll($sql);
//
//	$isc = null;
//	foreach ($res as $r) {
//		$isc[$r['prop']] = $r;
//		$isc[$r['prop']]['prop'] = $r['prop'];
//	}
//
//
//	var_dump($isc);
//}

if ($cmd == "getImages") {



	$sql = "
SELECT code,invfile,type,type2 FROM armor
UNION ALL
SELECT code,invfile,type,type2 FROM misc
UNION ALL
SELECT code,invfile,type,type2 FROM weapons
";

	$res = PDO_FetchAll($sql);

	$isc = null;
	foreach ($res as $r) {
		$isc1[$r['code']] = $r;
		$isc1[$r['code']]['code'] = $r['prop'];

		$isc2[$r['type']] = $r;
		$isc2[$r['type']]['type'] = $r['prop'];
	}

	$isc = array_merge($isc1, $isc2);

	unset($isc1);
	unset($isc2);

	var_dump(($isc));
}





/*
 * 	Gem Doc Generator
 *
 *
 *
 */




if ($cmd == "genDocGems") {
	$sql = "
SELECT g.*,m.invfile,m.type,m.type2,s.String
FROM gems as g
LEFT JOIN misc as m
ON g.code = m.code
LEFT JOIN strings as s
ON g.code = s.Key
";

	$res = array_filter(PDO_FetchAll($sql));

	//ddump($res);


	foreach ($res as $r) {
		for ($i = 1; $i <= 3; $i++) {
			$params = [
				'string1' => $isc[$r["weaponMod{$i}Code"]]['string1'],
				'string2' => $isc[$r["weaponMod{$i}Code"]]['string2'],
				'gstring1' => $isc[$r["weaponMod{$i}Code"]]['gstring'],
				'gstring2' => $isc[$r["weaponMod{$i}Code"]]['gstring2'],
				'descfunc' => $isc[$r["weaponMod{$i}Code"]]['descfunc'],
				'descval' => $isc[$r["weaponMod{$i}Code"]]['descval'],
				'dgrp' => $isc[$r["weaponMod{$i}Code"]]['dgrp'],
				'dgrpfunc' => $isc[$r["weaponMod{$i}Code"]]['dgrpfunc'],
				'dgrpval' => $isc[$r["weaponMod{$i}Code"]]['dgrpval'],
				"prop" => $isc[$r["weaponMod{$i}Code"]]['prop']
			];
			// weapons
			$params["par"] = $r["weaponMod{$i}Param"];
			$params["min"] = $r["weaponMod{$i}Min"];
			$params["max"] = $r["weaponMod{$i}Max"];
			if ($r["weaponMod{$i}Code"]) {
				$r["weaponMod{$i}Code"] = $idesc->getDesc($params);
			}

			//var_dump($params);

			$params = [
				'string1' => $isc[$r["helmMod{$i}Code"]]['string1'],
				'string2' => $isc[$r["helmMod{$i}Code"]]['string2'],
				'gstring1' => $isc[$r["helmMod{$i}Code"]]['gstring'],
				'gstring2' => $isc[$r["helmMod{$i}Code"]]['gstring2'],
				'descfunc' => $isc[$r["helmMod{$i}Code"]]['descfunc'],
				'descval' => $isc[$r["helmMod{$i}Code"]]['descval'],
				'dgrp' => $isc[$r["helmMod{$i}Code"]]['dgrp'],
				'dgrpfunc' => $isc[$r["helmMod{$i}Code"]]['dgrpfunc'],
				'dgrpval' => $isc[$r["helmMod{$i}Code"]]['dgrpval'],
				"prop" => $isc[$r["helmMod{$i}Code"]]['prop']
			];

			// helms
			$params["par"] = $r["helmMod{$i}Param"];
			$params["min"] = $r["helmMod{$i}Min"];
			$params["max"] = $r["helmMod{$i}Max"];
			if ($r["helmMod{$i}Code"]) {
				$r["helmMod{$i}Code"] = $idesc->getDesc($params);
			}
			//var_dump($params);

			$params = [
				'string1' => $isc[$r["helmMod{$i}Code"]]['string1'],
				'string2' => $isc[$r["helmMod{$i}Code"]]['string2'],
				'gstring1' => $isc[$r["helmMod{$i}Code"]]['gstring'],
				'gstring2' => $isc[$r["helmMod{$i}Code"]]['gstring2'],
				'descfunc' => $isc[$r["helmMod{$i}Code"]]['descfunc'],
				'descval' => $isc[$r["helmMod{$i}Code"]]['descval'],
				'dgrp' => $isc[$r["helmMod{$i}Code"]]['dgrp'],
				'dgrpfunc' => $isc[$r["helmMod{$i}Code"]]['dgrpfunc'],
				'dgrpval' => $isc[$r["helmMod{$i}Code"]]['dgrpval'],
				"prop" => $isc[$r["helmMod{$i}Code"]]['prop']
			];

			//shields
			$params["par"] = $r["shieldMod{$i}Param"];
			$params["min"] = $r["shieldMod{$i}Min"];
			$params["max"] = $r["shieldMod{$i}Max"];
			if ($r["shieldMod{$i}Code"]) {
				$r["shieldMod{$i}Code"] = $idesc->getDesc($params);
			}

			//var_dump($params);

			if (str_contains($r['String'], "ÿc")) {
				$p = "/ÿc[\d:;\/.]/i";
				$r['String'] = preg_replace($p, "", $r['String']);
			}
		}
		$gems[] = array_filter($r);
	}


	$htmlFinal = '';
	$htmlFinal .= $htmltop;
	//echo $htmltop;
	//ob_flush();
	$css = <<<EOT
	<style>

	body{
		background: white;
		color: black;
		font-family: ExocetLight;
		text-transform: uppercase;
	}



	 table, table th, table td, table tr {
		background: #111;
		color: #ccc;
   }

	.item_stats{
		width: auto;
		height: auto;
	}
	.item_desc {
		height: auto;
		text-align: center;
		padding: 10px;
		text-transform: uppercase;
	}
	.green {
		color: #00FF00; /*Set items*/
	}
	.gold{
		color: #A59263; /*Set items*/
	}
	.orange{
		color: #FFA500; /*Set items*/
	}
	.yellow {
		color: #FFFF00; /*Set items*/
	}

    .blue {
		color: #4169E1;
    }

	table {
    }

	.desc {
		width: 200px;
		font-family: ExocetLight;
		font-size: 1.25em;
		text-transform: uppercase;
		background: #111;
    }

	.input1,.input3,.input5,.input7{
		background: #444;
    }
	.input2, .input4, .input6 {
		background: #333;
    }
	.output1{
		background: #222;
	}
	.output2 {
		background: #222;
	}
	.output3 {
		background: #222;
	}

	td {

		height: 240px;
		text-align: center;
		vertical-align: middle;
		padding: 10px;
		white-space: nowrap;
	}


	img {
		height: 56px;
		width: auto;
    }

	</style>
EOT;
	//echo $css;
	$htmlFinal .= $css;
	//ob_flush();
	$table = <<<EOT
	<table border=1 class="gemtable">
	<thead>
		<tr>
			<th>Name</th>
			<th>Code</th>
			<th>Type</th>
			<th>Mods</th>
			<th>Weapons</th>
			<th>Helms</th>
			<th>Shields</th>
		</tr>
	</thead>
	<tbody>
EOT;
	//echo $table;
	$htmlFinal .= $table;
	//ob_flush();
	//ddump($isc);
	//ddump($idesc->getDesc($isc['cold-len']));
	//ddump($gems);
	//$x = array_shift($gems);

	foreach ($gems as $g) {

		if ($g['name'] == "Expansion") {
			continue;
		}


		$htmlRow = "<tr>";
		$htmlRow .= "<td class='name'>
						<img style='height: 64px;width:64px;' src='img/items/{$g["invfile"]}.png'><br>
						{$g['String']}
					</td>
				   ";
		$htmlRow .= "<td class='code'>
						{$g['code']}
					</td>
				   ";
		$htmlRow .= "<td class='type'>
						{$g['type']}
					</td>
				   ";
		$htmlRow .= "<td class='nummods'>
						Mods: {$g['nummods']}
					</td>
				   ";
		$htmlRow .= "<td class='weapons blue'>
						<img src='img/weapon.png'><br>
						{$g['weaponMod1Code']}<br>
						{$g['weaponMod2Code']}<br>
						{$g['weaponMod3Code']}<br>
					</td>
				   ";
		$htmlRow .= "<td class='helms gold'>
					<img src='img/helm.png'><br>
						{$g['helmMod1Code']}<br>
						{$g['helmMod2Code']}<br>
						{$g['helmMod3Code']}<br>
					</td>
				   ";
		$htmlRow .= "<td class='shields'>
					<img src='img/shield.png'><br>
						{$g['shieldMod1Code']}<br>
						{$g['shieldMod2Code']}<br>
						{$g['shieldMod3Code']}<br>
					</td>
				   ";

		$htmlRow .= "</tr>";

		$htmlFinal .= $htmlRow;
//		echo $htmlRow;
//		ob_flush();
	}

	$htmlFinal .= $tableBottom . $htmlbottom;
//	echo $tableBottom . $htmlbottom;
//	ob_flush();
//
//	ob_start();
	file_put_contents("$dir/gems.html", $htmlFinal);
	header("Location: /docs/{$_SESSION['modname']}/gems.html");
}


/*
*
*
* @cmd = genDocRunewords
*
*/


if ($cmd == 'genDocRunewords'){

   // ddump($_SESSION);
    
	//ddump($isc);

	$sql = 'SELECT * FROM runes';
	$runes = array_filter(PDO_FetchAll($sql));
        
          $sql = 'SELECT code,invfile from misc';
          $rune_inv_codes = array_filter(PDO_FetchAssoc($sql));
          
         // ddump($rune_inv_codes);
        

	$sql = 'SELECT * FROM strings';
	$strings =  array_filter(PDO_FetchAssoc($sql));

	$sql = 'SELECT Itemtype,Code,Equiv1 FROM itemtypes';
	$itypes =  array_flip(array_filter(PDO_FetchAssoc($sql)));

	$tableTop = <<<EOT
	<table class="rtable rw">
	  <thead>
		<tr>
		  <th>Name</th>
		  <th>Runes</th>                
		  <th>Properties</th>
		</tr>
	  </thead>
	  <tbody>
	EOT;

	foreach ($runes as $rune){
		// Grab Rune Names
		
		$name = $strings[$rune['Name']];

		$itype1 = $itypes[$rune['itype1']];
		$itype2 = $itypes[$rune['itype2']];
		$itype3 = $itypes[$rune['itype3']];
		$itype4 = $itypes[$rune['itype4']];
		$itype5 = $itypes[$rune['itype5']];
		$itype6 = $itypes[$rune['itype6']];
                
                
                     $rr_img[1] = $rune_inv_codes[$rune['Rune1']];
                     $rr_img[2] = $rune_inv_codes[$rune['Rune2']];
                     $rr_img[3] = $rune_inv_codes[$rune['Rune3']];
                     $rr_img[4] = $rune_inv_codes[$rune['Rune4']];
                     $rr_img[5] = $rune_inv_codes[$rune['Rune5']];
                     $rr_img[6] = $rune_inv_codes[$rune['Rune6']];                             
                   

		$rr[1] = str_replace('', '', $strings[$rune['Rune1']]);
		$rr[2] = str_replace('', '', $strings[$rune['Rune2']]);
		$rr[3] = str_replace('', '', $strings[$rune['Rune3']]);
		$rr[4] = str_replace('', '', $strings[$rune['Rune4']]);
		$rr[5] = str_replace('', '', $strings[$rune['Rune5']]);
		$rr[6] = str_replace('', '', $strings[$rune['Rune6']]);	

		if (str_contains($rr[1], "ÿc")) {
			$p = "/ÿc[\d:;\/.]/i";
			$rr[1] = preg_replace($p, "", $rr[1]);
		}
		if (str_contains($rr[2], "ÿc")) {
			$p = "/ÿc[\d:;\/.]/i";
			$rr[2] = preg_replace($p, "", $rr[2]);
		}
		if (str_contains($rr[3], "ÿc")) {
			$p = "/ÿc[\d:;\/.]/i";
			$rr[3] = preg_replace($p, "", $rr[3]);
		}
		if (str_contains($rr[4], "ÿc")) {
			$p = "/ÿc[\d:;\/.]/i";
			$rr[4] = preg_replace($p, "", $rr[4]);
		}
		if (str_contains($rr[5], "ÿc")) {
			$p = "/ÿc[\d:;\/.]/i";
			$rr[5] = preg_replace($p, "", $rr[5]);
		}
		if (str_contains($rr[6], "ÿc")) {
			$p = "/ÿc[\d:;\/.]/i";
			$rr[6] = preg_replace($p, "", $rr[6]);
		}                
                
                    $rr = array_filter($rr);
                    $rune_count = count($rr);
                    $rune_count_duplicates = array_count_values($rr);
                    
//                    echo "<pre>";
//                    var_dump($rune_count_duplicates);
                    
                    $rcd = null;
                    foreach ($rune_count_duplicates as $k => $v){
                        // rune * count
                        $rcd[] = "$k <span class='numrunes blue'>x</span> <span style='font-size: 2em;'>$v</span>"; 
                    }
		
//                   echo "<pre>";
//                   var_dump($rcd);
                
          
                
                for ($i = 1; $i <= 7; $i++){

                    if($rune["T1Code{$i}"] != ''){

                    $params = [
                            "string1" => $isc[$rune["T1Code{$i}"]]["string1"],
                            "string2" => $isc[$rune["T1Code{$i}"]]["string2"],
                            "gstring1" => $isc[$rune["T1Code{$i}"]]["gstring"],
                            "gstring2" => $isc[$rune["T1Code{$i}"]]["gstring2"],
                            "descfunc" => $isc[$rune["T1Code{$i}"]]["descfunc"],
                            "descval" => $isc[$rune["T1Code{$i}"]]["descval"],
                            "dgrp" => $isc[$rune["T1Code{$i}"]]["dgrp"],
                            "dgrpfunc" => $isc[$rune["T1Code{$i}"]]["dgrpfunc"],
                            "dgrpval" => $isc[$rune["T1Code{$i}"]]["dgrpval"],
                            "prop" => $isc[$rune["T1Code{$i}"]]["prop"]
                    ];
                    $params["par"] = $rune["T1Param{$i}"];
                    $params["min"] = $rune["T1Min{$i}"];
                    $params["max"] = $rune["T1Max{$i}"];

                    $props[$i] = $idesc->getDesc($params);               
                    } 
                }

                $props = array_unique($props);
                
                // for each $rune, echo props
//                echo "<pre>";
//                var_dump($props);
                
                
                $rr_img = array_filter($rr_img);

                $img_s = '';
                foreach ($rr_img as $k){
                    $img_s .= "<img class='rune-img' src='img/items/{$k}.png'>";                    
                }
                
                //ddump($img_s);
                
                $tableRowsRunes .= <<<EOT


    <tr class="rw">
      <td>
          <p class="rw-name gold">$name</p>
          <p class="rw-type">$itype1<br> $itype2<br> $itype3<br> $itype4<br> $itype5<br> $itype6</p>              
      </td>
      <td>
          <p class="rw-rune">
                     <p>$img_s</p>
                     $rcd[0] <br>
                     $rcd[1] <br>
                     $rcd[2] <br>
                     $rcd[3] <br>
                     $rcd[4] <br>
                     $rcd[5] <br>
                     <!--<p class="rw-count">$rune_count</p>-->
   
          </p></td>

            <td>
		<ul class="rprops blue">
                        <li style="font-size: 140%;margin: 5px;" class="gold">$name</li>
                        <li> $props[1] </li>
                        <li> $props[2] </li>
                        <li> $props[3] </li>
                        <li> $props[4] </li>
                        <li> $props[5] </li>
                        <li> $props[6] </li>
                        <li> $props[7] </li>
		</ul>
	  </td>
    </tr>

	
EOT;	
	}
        
        
echo $htmltop;
echo $tableTop;
echo $tableRowsRunes;
echo "</tbody></table>";
echo $htmlbottom;


$htmlFinal = $htmltop. $tableTop . $tableRowsRunes .$tableBottom ;


file_put_contents("$dir/runewords.html", $htmlFinal);
header("Location: docs/{$_SESSION['modname']}/runewords.html");


}
