<?php

/*

  Copyright (C) 2021 Hash Borgir

  This file is part of D2Modder

  Redistribution and use in source and binary forms, with
  or without modification, are permitted provided that the
  following conditions are met:

 * Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

 * Redistributions in binary form must reproduce the above
  copyright notice, this list of conditions and the
  following disclaimer in the documentation and/or other
  materials provided with the distribution.

 * This software must not be used for commercial purposes 
 * without my consent. Any sales or commercial use are prohibited
 * without my express knowledge and consent.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY!

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 */

class D2Database {

	public function __construct() {
		PDO_Connect("sqlite:" . DB_FILE);
	}

	public function createTables($file, $data) {
		$tableName = basename($file);
		$tableName = strtolower(substr($tableName, 0, -4));
		$sql = '';
		if (!empty($data[0])) {
			$sql = "CREATE TABLE IF NOT EXISTS `$tableName` (";
			foreach ($data[0] as $k => $v) {
				if (is_numeric($v)) {
					$dataType = "INT";
				} else {
					$dataType = "VARCHAR(255)";
				}
				$sql .= "`$k` $dataType DEFAULT '',";
			}
			$sql = rtrim($sql, ",");
			$sql .= ")";
			$res = PDO_Execute($sql);
		}
	}

	public function fillsTables($file, $data) {
		$tableName = basename($file);
		$tableName = strtolower(substr($tableName, 0, -4));

		$sql = '';
		if (!empty($data)) {
			foreach ($data as $d) {

				if (!empty($d)) {
					$sql = "INSERT INTO `$tableName` (";
					foreach ($d as $k => $v) {
						$sql .= "`$k`" . ",";
					}
					$sql = rtrim($sql, ",");
					$sql .= ") ";
				}
			}
		}

		if (!empty($data)) {
			$sql .= "VALUES ";
			foreach ($data as $d) {
				if (!empty($d)) {
					$sql .= "(";
					foreach ($d as $k => $v) {
						$sql .= '"' . $v . '"' . ",";
					}
					$sql = rtrim($sql, ",");
					$sql .= "), ";
				}
			}
			$sql = rtrim($sql, ", ");
			$sql .= ";";

			$res = PDO_Execute($sql);
		}
	}

	public function writeTbl($data) {
		$sql = 'CREATE TABLE IF NOT EXISTS `strings` (`Key` VARCHAR(255), `String` VARCHAR(255));';
		$res = PDO_Execute($sql);

		$sql = "INSERT INTO `strings` (`Key`,`String`) VALUES ";
		foreach ($data as $k => $v) {
			$sql .= "(\"$k\",\"$v\"),";
		}
		$sql = rtrim($sql, ", ");
		$sql .= ";";

		$res = PDO_Execute($sql);
	}

	public function getString($key) {
		$sql = "SELECT String FROM `strings` WHERE `Key`='$key'";

		$res = PDO_FetchRow($sql);
		return $res;
	}



}
